/*--------------------------------------------------*/
/* J[摜 Bayer p^[̃vO	*/
/*                                      			*/
/*  Initial     			2018/09/08  T.Kimura    */
/*                                      			*/
/*--------------------------------------------------*/
/*--------------------------------------------------*/
/* Copyright by T.Kimura 2018                       */
/*--------------------------------------------------*/

#include "stdio.h"
#include "stdlib.h"
#include "image.h"

#define		MONO_Depth	8		/* Mono color depth */

/*----------------------*/
/* Main Routine         */
/*----------------------*/
int main( int argv, char *argc[] )
{
	ImageData *in_img, *out_img;		/* Ǎ摜Co摜 */
	int 	x, y, res;
	int		p;							/* pixel data	*/
	Pixel 	pix;                        /* Pixel \ (r, g, b) */

	if( argv<3 ) {
        printf("p[^܂\n");
		printf("gen_bayer [read image file name] [write image file name]\n");
		return 1;
	}

   // t@C摜f[^̓ǂݍ
    res=readBMPfile( argc[1]/*read image*/, &in_img);
    if( res<0 ) {
        printf("摜f[^ǂ߂܂");
        return 1;
    }

    // i[p摜f[^쐬 (Mono Color:8bit)
    out_img = createImage( in_img->width, in_img->height, MONO_Depth );

    /*----------------------------------------------------------------------------------*/
    /* 摜f[^͓ǂݍ񂾎 img1 ɓCHEopƂăf[^ img2 ɓ */
    /*----------------------------------------------------------------------------------*/
    for( y=0 ; y<in_img->height ; y++ ){
        for( x=0 ; x<in_img->width ; x++ ) {
            getPixel(in_img, x, y, &pix);

            /* ꍇCXɋLq */

			/* Line ̎ */
			if( y%2==0 ) {
				/* f̉ʒuyz̎ [R] */
				if( x%2==0 ) {
					p = pix.r;
				}
				/* f̉ʒuyz̎ [G] */
				else {
					p = pix.g;
				}
			}
			/* Line ̎ */
			else {
				/* f̉ʒuyz̎ [G] */
				if( x%2==0 ) {
					p = pix.g;
				}
				/* f̉ʒuyz̎ [B] */
				else {
					p = pix.b;
				}
			}

			/* mono color ̏ꍇ Pixel\̂ r Ƀf[^ */
			pix.r = p;
            setPixel(out_img, x, y, &pix);
        }
    }

    // t@C։摜f[^o
    writeBMPfile( argc[2]/*write image*/, out_img);
    disposeImage(in_img);
    disposeImage(out_img);

    return 0;
}
